package com.minemaarten.signals.client.gui;

import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.player.InventoryPlayer;

import com.minemaarten.signals.capabilities.CapabilityMinecartDestination;
import com.minemaarten.signals.client.gui.widget.IGuiWidget;
import com.minemaarten.signals.inventory.ContainerMinecart;
import com.minemaarten.signals.network.NetworkHandler;
import com.minemaarten.signals.network.PacketUpdateTextfieldEntity;

public class GuiMinecart extends GuiDestinations<CapabilityMinecartDestination>{
    private final EntityMinecart cart;
    private final boolean isMotorized;

    public GuiMinecart(InventoryPlayer playerInventory, EntityMinecart cart, boolean isMotorized){
        super(new ContainerMinecart(playerInventory, cart, isMotorized), cart.getCapability(CapabilityMinecartDestination.INSTANCE, null));
        this.cart = cart;
        field_146999_f = isMotorized ? 295 : 120;
        this.isMotorized = isMotorized;
    }

    @Override
    protected void func_146976_a(float partialTicks, int i, int j){
        super.func_146976_a(partialTicks, i, j);
        drawDarkGreyText(field_147003_i, field_147009_r, "signals.gui.cart.schedule");

        if(isMotorized) {
            func_73728_b(field_147003_i + 120, field_147009_r - 1, field_147009_r + field_147000_g, 0xFF222222);
            drawDarkGreyText(field_147003_i + 120, field_147009_r, "signals.gui.cart.engine_fuel");

            int barSize = 87;
            func_73730_a(field_147003_i + 164, field_147003_i + 164 + barSize, field_147009_r + 67, 0xFF222222);
            int fuelSize = destinationAccessor.getScaledFuel(barSize + 1);
            if(fuelSize > 0) func_73730_a(field_147003_i + 164, field_147003_i + 164 + fuelSize - 1, field_147009_r + 67, 0xFFFF0000);
        }
    }

    @Override
    public void onKeyTyped(IGuiWidget widget){
        super.onKeyTyped(widget);

        NetworkHandler.sendToServer(new PacketUpdateTextfieldEntity(cart, 0));
    }
}
