package com.minemaarten.signals.client.gui.widget;

import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import net.minecraft.client.gui.FontRenderer;

import org.lwjgl.input.Keyboard;

public class WidgetComboBox extends WidgetTextField{

    private final ArrayList<String> elements = new ArrayList<>();
    private final FontRenderer fontRenderer;
    private boolean enabled = true;
    private boolean fixedOptions;

    public WidgetComboBox(FontRenderer fontRenderer, int x, int y, int width, int height){
        super(fontRenderer, x, y, width, height);
        this.fontRenderer = fontRenderer;
    }

    public WidgetComboBox setElements(Collection<String> elements){
        this.elements.clear();
        this.elements.addAll(elements);
        Collections.sort(this.elements);
        return this;
    }

    public WidgetComboBox setElements(String[] elements){
        this.elements.clear();
        this.elements.ensureCapacity(elements.length);
        for(String s : elements)
            this.elements.add(s);
        Collections.sort(this.elements);
        return this;
    }

    private List<String> getApplicableElements(){
        List<String> list = new ArrayList<>();
        for(String element : elements) {
            if(fixedOptions || element.toLowerCase().contains(func_146179_b().toLowerCase())) list.add(element);
        }
        return list;
    }

    @Override
    public void postRender(int mouseX, int mouseY, float partialTick){
        super.postRender(mouseX, mouseY, partialTick);
        if(enabled && func_146206_l()) {
            List<String> applicableElements = getApplicableElements();
            func_73734_a(field_146209_f - 1, field_146210_g + field_146219_i + 1, field_146209_f + field_146218_h + 1, field_146210_g + field_146219_i + 3 + applicableElements.size() * fontRenderer.field_78288_b, -6250336);
            func_73734_a(field_146209_f, field_146210_g + field_146219_i + 1, field_146209_f + field_146218_h, field_146210_g + field_146219_i + 2 + applicableElements.size() * fontRenderer.field_78288_b, -16777216);
            for(int i = 0; i < applicableElements.size(); i++) {
                String element = applicableElements.get(i);
                fontRenderer.func_175063_a(fontRenderer.func_78269_a(element, func_146200_o()), field_146209_f + 4, field_146210_g + field_146219_i + 2 + i * fontRenderer.field_78288_b, 14737632);
            }
        }
    }

    @Override
    public void onMouseClicked(int mouseX, int mouseY, int button){
        if(!fixedOptions || button != 1) super.onMouseClicked(mouseX, mouseY, button);
        if(enabled) {
            func_146195_b(true);
            List<String> applicableElements = getApplicableElements();
            for(int i = 0; i < applicableElements.size(); i++) {
                if(new Rectangle(field_146209_f - 1, field_146210_g + field_146219_i + 2 + i * fontRenderer.field_78288_b, field_146218_h, fontRenderer.field_78288_b).contains(mouseX, mouseY)) {
                    func_146180_a(applicableElements.get(i));
                    listener.onKeyTyped(this);
                    func_146195_b(false);
                    break;
                }
            }
        }
    }

    @Override
    public void onMouseClickedOutsideBounds(int mouseX, int mouseY, int button){
        func_146195_b(false);
    }

    @Override
    public Rectangle getBounds(){
        return enabled && func_146206_l() ? new Rectangle(field_146209_f, field_146210_g, field_146218_h, field_146219_i + 2 + getApplicableElements().size() * fontRenderer.field_78288_b) : super.getBounds();
    }

    @Override
    public boolean onKey(char key, int keyCode){
        if(fixedOptions) return false;
        if(enabled && func_146206_l() && keyCode == Keyboard.KEY_TAB) {//Auto-complete
            List<String> applicableElements = getApplicableElements();
            if(applicableElements.size() > 0) {
                func_146180_a(applicableElements.get(0));
                listener.onKeyTyped(this);
                return true;
            } else {
                return super.onKey(key, keyCode);
            }
        } else {
            return super.onKey(key, keyCode);
        }
    }

    @Override
    public void func_146184_c(boolean enabled){
        super.func_146184_c(enabled);
        this.enabled = enabled;
    }

    public WidgetComboBox setFixedOptions(){
        fixedOptions = true;
        return this;
    }
}
